{   BePascal - A pascal wrapper around the BeOS API
    Copyright (C) 2003 Olivier Coursiere
                       Eric Jourde
                       Oscar Lesta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit point;

interface

uses
  BeObj, Archivable, GraphicDefs, Message, OS, Rect, SupportDefs,dataio;

type

  BPoint = class(TBeObject)
  private
  	 	function Get_X : Real;
  	 	function Get_Y : Real;
  public
    
    constructor Create;override; 
    constructor Create(fx,fy : real);
    constructor Create(data : BPoint);

    destructor Destroy; override;
	procedure ConstrainTo( rect : Brect);
	procedure PrintToStream;
	procedure Set_(fx,fy : real);

	published 
		Property X : real read Get_X;
		Property Y : real read Get_Y;
  end;

function BPoint_Create(AObject : TCPlusObject) : TCPlusObject; cdecl;  external BePascalLibName name 'BPoint_Create_3';
function BPoint_Create(AObject : TCPlusObject;fx,fy : real) : TCPlusObject; cdecl;  external BePascalLibName name 'BPoint_Create_1';
function BPoint_Create(AObject : TCPlusObject;data : BPoint) : TCPlusObject; cdecl;  external BePascalLibName name 'BPoint_Create_2';

procedure BPoint_Free(AObject : TCPlusObject); cdecl;  external BePascalLibName name 'BPoint_Free';
procedure BPoint_ConstrainTo(AObject : TCPlusObject; rect : Brect);cdecl;  external BePascalLibName name 'BPoint_ConstrainTo';
procedure BPoint_PrintToStream(AObject : TCPlusObject);cdecl;  external BePascalLibName name 'BPoint_PrintToStream';
function BPoint_Get_X( AObject : TCPlusObject) : real;cdecl;  external BePascalLibName name 'BPoint_Get_X';
function BPoint_Get_Y(AObject : TCPlusObject): real ;cdecl;  external BePascalLibName name 'BPoint_Get_Y';
procedure BPoint_Set_(AObject : TCPlusObject;x,y : real);cdecl;  external BePascalLibName name 'BPoint_Set';



implementation



constructor BPoint.Create;
begin
  CreatePas;
  CPlusObject := BPoint_Create(Self);
end;
constructor BPoint.Create(fx,fy : real);
begin
  CreatePas;
  CPlusObject := BPoint_Create(Self,fx,fy);
end;
constructor BPoint.Create(data : BPoint);
begin
  CreatePas;
  CPlusObject := BPoint_Create(Self,data);
end;



destructor BPoint.Destroy;
begin
  BPoint_Free(CPlusObject);
  inherited;
end;

procedure BPoint.ConstrainTo( rect : Brect);
begin
	BPoint_ConstrainTo(CPlusObject,rect);
end;

procedure BPoint.PrintToStream;
begin
	BPoint_PrintToStream(CPlusObject);
end;

function BPoint.Get_X : Real;
begin
	result:=BPoint_Get_X(CPlusObject);
end;

function BPoint.Get_Y : Real;
begin
	result:=BPoint_Get_Y(CPlusObject);
end;

procedure BPoint.Set_(fx,fy : real);
begin
	BPoint_Set_(CPlusObject,fx,fy);
end;


end.
